## rclone 1.35

=== Makefile ===
SHELL = /bin/bash
TAG := $(shell echo `git describe --tags`-`git rev-parse --abbrev-ref HEAD` | sed 's/-\([0-9]\)-/-0\1-/; s/-\(HEAD\|master\)$$//')
LAST_TAG := $(shell git describe --tags --abbrev=0)
NEW_TAG := $(shell echo $(LAST_TAG) | perl -lpe 's/v//; $$_ += 0.01; $$_ = sprintf("v%.2f", $$_)')
GO_VERSION := $(shell go version)
GO_FILES := $(shell go list ./... | grep -v /vendor/ )
GO_LATEST := $(findstring go1.7,$(GO_VERSION))
BETA_URL := http://beta.rclone.org/$(TAG)/
# Only needed for Go 1.5
export GO15VENDOREXPERIMENT=1

rclone:
	go install -v

vars:
	@echo SHELL="'$(SHELL)'"
	@echo TAG="'$(TAG)'"
	@echo LAST_TAG="'$(LAST_TAG)'"
	@echo NEW_TAG="'$(NEW_TAG)'"
	@echo GO_VERSION="'$(GO_VERSION)'"
	@echo GO_LATEST="'$(GO_LATEST)'"
	@echo BETA_URL="'$(BETA_URL)'"

# Full suite of integration tests
test:	rclone
	go test $(GO_FILES)
	cd fs && go run test_all.go

# Quick test
quicktest:
	go test $(GO_FILES)
	go test -cpu=2 -race $(GO_FILES)

# Do source code quality checks
check:	rclone
ifdef GO_LATEST
	go vet $(GO_FILES)
	errcheck $(GO_FILES)
	find . -name \*.go | grep -v /vendor/ | xargs goimports -d | grep . ; test $$? -eq 1
	go list ./... | grep -v /vendor/ | xargs -i golint {} | grep -E -v '(StorageUrl|CdnUrl)' ; test $$? -eq 1
else
	@echo Skipping tests as not on Go stable
endif

# Get the build dependencies
build_dep:
ifdef GO_LATEST
	go get -u github.com/kisielk/errcheck
	go get -u golang.org/x/tools/cmd/goimports
	go get -u github.com/golang/lint/golint
	go get -u github.com/mitchellh/gox
	go get -u github.com/inconshreveable/mousetrap
	go get -u github.com/tools/godep
endif

# Update dependencies
update:
	rm -rf Godeps vendor
	go get -t -u -f -v ./...
	godep save ./...

doc:	rclone.1 MANUAL.html MANUAL.txt

rclone.1:	MANUAL.md
	pandoc -s --from markdown --to man MANUAL.md -o rclone.1

MANUAL.md:	bin/make_manual.py docs/content/*.md commanddocs
	./bin/make_manual.py

MANUAL.html:	MANUAL.md
	pandoc -s --from markdown --to html MANUAL.md -o MANUAL.html

MANUAL.txt:	MANUAL.md
	pandoc -s --from markdown --to plain MANUAL.md -o MANUAL.txt

commanddocs: rclone
	rclone gendocs docs/content/commands/

install: rclone
	install -d ${DESTDIR}/usr/bin
	install -t ${DESTDIR}/usr/bin ${GOPATH}/bin/rclone

clean:
	go clean ./...
	find . -name \*~ | xargs -r rm -f
	rm -rf build docs/public
	rm -f rclone rclonetest/rclonetest

website:
	cd docs && hugo

upload_website:	website
	rclone -v sync docs/public memstore:www-rclone-org

upload:
	rclone -v copy build/ memstore:downloads-rclone-org

upload_github:
	./bin/upload-github $(TAG)

cross:	doc
	./bin/cross-compile $(TAG)

beta:
	./bin/cross-compile $(TAG)β
	rm build/*-current-*
	rclone -v copy build/ memstore:pub-rclone-org/$(TAG)β
	@echo Beta release ready at http://pub.rclone.org/$(TAG)%CE%B2/

travis_beta:
	./bin/cross-compile $(TAG)β
	rm build/*-current-*
	rclone --config bin/travis.rclone.conf -v copy build/ memstore:beta-rclone-org/$(TAG)
	@echo Beta release ready at $(BETA_URL)

serve:	website
	cd docs && hugo server -v -w

tag:	doc
	@echo "Old tag is $(LAST_TAG)"
	@echo "New tag is $(NEW_TAG)"
	echo -e "package fs\n\n// Version of rclone\nvar Version = \"$(NEW_TAG)-DEV\"\n" | gofmt > fs/version.go
	perl -lpe 's/VERSION/${NEW_TAG}/g; s/DATE/'`date -I`'/g;' docs/content/downloads.md.in > docs/content/downloads.md
	git tag $(NEW_TAG)
	@echo "Add this to changelog in docs/content/changelog.md"
	@echo "  * $(NEW_TAG) -" `date -I`
	@git log $(LAST_TAG)..$(NEW_TAG) --oneline
	@echo "Then commit the changes"
	@echo git commit -m \"Version $(NEW_TAG)\" -a -v
	@echo "And finally run make retag before make cross etc"

retag:
	git tag -f $(LAST_TAG)

gen_tests:
	cd fstest/fstests && go generate

=== debian/changelog ===
rclone (1.35-1) unstable; urgency=medium

  * Imported Upstream version 1.35
  * Refresh patches
  * Update bash completion script with new commands

 -- Dr. Tobias Quathamer <toddy@debian.org>  Tue, 03 Jan 2017 16:56:28 +0100

rclone (1.34-2) unstable; urgency=medium

  * Add rules for repackaging to d/copyright and d/watch
  * Replace golang-golang-x-oauth2-dev with golang-golang-x-oauth2-google-dev.
    Thanks to Aaron M. Ucko <amu@alum.mit.edu> (Closes: #846037)
  * Build-Depend on golang-any instead of golang-go
  * Add bash-completion script generated by rclone

 -- Dr. Tobias Quathamer <toddy@debian.org>  Mon, 28 Nov 2016 17:53:27 +0100

rclone (1.34-1) unstable; urgency=medium

  * Initial release (Closes: #822793)

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sat, 12 Nov 2016 17:33:16 +0100

=== debian/control ===
Source: rclone
Section: net
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Dr. Tobias Quathamer <toddy@debian.org>
Build-Depends: debhelper (>= 10),
               dh-golang,
               bash-completion,
               golang-any,
               golang-bazil-fuse-dev,
               golang-github-aws-aws-sdk-go-dev,
               golang-github-mreiferson-go-httpclient-dev,
               golang-github-ncw-go-acd-dev,
               golang-github-ncw-swift-dev,
               golang-github-pkg-errors-dev,
               golang-github-rfjakob-eme-dev,
               golang-github-skratchdot-open-golang-dev,
               golang-github-spf13-cobra-dev,
               golang-github-spf13-pflag-dev,
               golang-github-stacktic-dropbox-dev,
               golang-github-stretchr-testify-dev,
               golang-github-tsenart-tb-dev,
               golang-github-unknwon-goconfig-dev,
               golang-github-vividcortex-ewma-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev,
               golang-golang-x-oauth2-google-dev,
               golang-golang-x-sys-dev,
               golang-golang-x-text-dev,
               golang-google-api-dev,
# This package is needed for testing only
               fuse
Standards-Version: 3.9.8
Homepage: https://github.com/ncw/rclone
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/rclone.git
Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/rclone.git
XS-Go-Import-Path: github.com/ncw/rclone

Package: rclone
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: rsync for commercial cloud storage
 Rclone is a program to sync files and directories between the local
 file system and a variety of commercial cloud storage providers:
 .
  - Google Drive
  - Amazon S3
  - Openstack Swift / Rackspace cloud files / Memset Memstore
  - Dropbox
  - Google Cloud Storage
  - Amazon Drive
  - Microsoft One Drive
  - Hubic
  - Backblaze B2
  - Yandex Disk

Package: golang-github-ncw-rclone-dev
Section: devel
Priority: extra
Architecture: all
Built-Using: ${misc:Built-Using}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         golang-bazil-fuse-dev,
         golang-github-aws-aws-sdk-go-dev,
         golang-github-mreiferson-go-httpclient-dev,
         golang-github-ncw-go-acd-dev,
         golang-github-ncw-swift-dev,
         golang-github-pkg-errors-dev,
         golang-github-rfjakob-eme-dev,
         golang-github-skratchdot-open-golang-dev,
         golang-github-spf13-cobra-dev,
         golang-github-spf13-pflag-dev,
         golang-github-stacktic-dropbox-dev,
         golang-github-stretchr-testify-dev,
         golang-github-tsenart-tb-dev,
         golang-github-unknwon-goconfig-dev,
         golang-github-vividcortex-ewma-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev,
         golang-golang-x-oauth2-google-dev,
         golang-golang-x-sys-dev,
         golang-golang-x-text-dev,
         golang-google-api-dev
Description: go source code of rclone
 Rclone is a program to sync files and directories between the local
 file system and a variety of commercial cloud storage providers.
 .
 This package contains rclone's source code.

## rclone 1.36

=== Makefile ===
--- 
+++ 
@@ -4,13 +4,17 @@
 NEW_TAG := $(shell echo $(LAST_TAG) | perl -lpe 's/v//; $$_ += 0.01; $$_ = sprintf("v%.2f", $$_)')
 GO_VERSION := $(shell go version)
 GO_FILES := $(shell go list ./... | grep -v /vendor/ )
-GO_LATEST := $(findstring go1.7,$(GO_VERSION))
+GO_LATEST := $(findstring go1.8,$(GO_VERSION))
 BETA_URL := http://beta.rclone.org/$(TAG)/
 # Only needed for Go 1.5
 export GO15VENDOREXPERIMENT=1
 
+.PHONY: rclone
+
 rclone:
-	go install -v
+	touch fs/version.go
+	go install -v --ldflags "-s -X github.com/ncw/rclone/fs.Version=$(TAG)"
+	cp -av `go env GOPATH`/bin/rclone .
 
 vars:
 	@echo SHELL="'$(SHELL)'"
@@ -28,13 +32,13 @@
 
 # Quick test
 quicktest:
-	go test $(GO_FILES)
-	go test -cpu=2 -race $(GO_FILES)
+	RCLONE_CONFIG="/notfound" go test $(GO_FILES)
+	RCLONE_CONFIG="/notfound" go test -cpu=2 -race $(GO_FILES)
 
 # Do source code quality checks
 check:	rclone
 ifdef GO_LATEST
-	go vet $(GO_FILES)
+	go tool vet -printfuncs Debugf,Infof,Logf,Errorf . 2>&1 | grep -E -v vendor/ ; test $$? -eq 1
 	errcheck $(GO_FILES)
 	find . -name \*.go | grep -v /vendor/ | xargs goimports -d | grep . ; test $$? -eq 1
 	go list ./... | grep -v /vendor/ | xargs -i golint {} | grep -E -v '(StorageUrl|CdnUrl)' ; test $$? -eq 1
@@ -48,7 +52,6 @@
 	go get -u github.com/kisielk/errcheck
 	go get -u golang.org/x/tools/cmd/goimports
 	go get -u github.com/golang/lint/golint
-	go get -u github.com/mitchellh/gox
 	go get -u github.com/inconshreveable/mousetrap
 	go get -u github.com/tools/godep
 endif
@@ -99,18 +102,18 @@
 	./bin/upload-github $(TAG)
 
 cross:	doc
-	./bin/cross-compile $(TAG)
+	go run bin/cross-compile.go -release current $(TAG)
 
 beta:
-	./bin/cross-compile $(TAG)β
-	rm build/*-current-*
+	go run bin/cross-compile.go $(TAG)β
 	rclone -v copy build/ memstore:pub-rclone-org/$(TAG)β
 	@echo Beta release ready at http://pub.rclone.org/$(TAG)%CE%B2/
 
 travis_beta:
-	./bin/cross-compile $(TAG)β
-	rm build/*-current-*
-	rclone --config bin/travis.rclone.conf -v copy build/ memstore:beta-rclone-org/$(TAG)
+	git log $(LAST_TAG).. > /tmp/git-log.txt
+	go run bin/cross-compile.go -release beta-latest -git-log /tmp/git-log.txt $(TAG)β
+	rclone --config bin/travis.rclone.conf -v copy --exclude '*beta-latest*' build/ memstore:beta-rclone-org/$(TAG)
+	rclone --config bin/travis.rclone.conf -v copy --include '*beta-latest*' build/ memstore:beta-rclone-org
 	@echo Beta release ready at $(BETA_URL)
 
 serve:	website
@@ -119,18 +122,20 @@
 tag:	doc
 	@echo "Old tag is $(LAST_TAG)"
 	@echo "New tag is $(NEW_TAG)"
-	echo -e "package fs\n\n// Version of rclone\nvar Version = \"$(NEW_TAG)-DEV\"\n" | gofmt > fs/version.go
+	echo -e "package fs\n\n// Version of rclone\nvar Version = \"$(NEW_TAG)\"\n" | gofmt > fs/version.go
 	perl -lpe 's/VERSION/${NEW_TAG}/g; s/DATE/'`date -I`'/g;' docs/content/downloads.md.in > docs/content/downloads.md
 	git tag $(NEW_TAG)
-	@echo "Add this to changelog in docs/content/changelog.md"
-	@echo "  * $(NEW_TAG) -" `date -I`
-	@git log $(LAST_TAG)..$(NEW_TAG) --oneline
+	@echo "Edit the new changelog in docs/content/changelog.md"
+	@echo "  * $(NEW_TAG) -" `date -I` >> docs/content/changelog.md
+	@git log $(LAST_TAG)..$(NEW_TAG) --oneline >> docs/content/changelog.md
 	@echo "Then commit the changes"
 	@echo git commit -m \"Version $(NEW_TAG)\" -a -v
 	@echo "And finally run make retag before make cross etc"
 
 retag:
 	git tag -f $(LAST_TAG)
+	echo -e "package fs\n\n// Version of rclone\nvar Version = \"$(LAST_TAG)-DEV\"\n" | gofmt > fs/version.go
+	git commit -m "Start $(LAST_TAG)-DEV development" fs/version.go
 
 gen_tests:
 	cd fstest/fstests && go generate

=== debian/changelog ===
rclone (1.36-3) unstable; urgency=medium

  * Team upload.
  * Add missing build-dep golang-github-pkg-sftp-dev

 -- Michael Stapelberg <stapelberg@debian.org>  Sun, 30 Jul 2017 19:42:48 +0200

rclone (1.36-2) unstable; urgency=medium

  * Add 0004-Fix-test-failure.patch to fix FTBFS (Closes: #869376)

 -- Michael Stapelberg <stapelberg@debian.org>  Sun, 23 Jul 2017 22:11:42 +0200

rclone (1.36-1) unstable; urgency=medium

  * New upstream version 1.36
    - Refresh patches
  * Use autopkgtest-pkg-go
  * Update d/copyright
  * Update to Standards-Version 4.0.0

 -- Dr. Tobias Quathamer <toddy@debian.org>  Mon, 03 Jul 2017 13:33:56 +0200

=== debian/control ===
--- 
+++ 
@@ -28,13 +28,15 @@
                golang-golang-x-sys-dev,
                golang-golang-x-text-dev,
                golang-google-api-dev,
+               golang-github-pkg-sftp-dev,
 # This package is needed for testing only
                fuse
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: https://github.com/ncw/rclone
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/rclone.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-go/packages/rclone.git
 XS-Go-Import-Path: github.com/ncw/rclone
+Testsuite: autopkgtest-pkg-go
 
 Package: rclone
 Architecture: any
@@ -83,7 +85,8 @@
          golang-golang-x-oauth2-google-dev,
          golang-golang-x-sys-dev,
          golang-golang-x-text-dev,
-         golang-google-api-dev
+         golang-google-api-dev,
+         golang-github-pkg-sftp-dev
 Description: go source code of rclone
  Rclone is a program to sync files and directories between the local
  file system and a variety of commercial cloud storage providers.

=== debian/rules ===
#!/usr/bin/make -f

# Include test fixtures
export DH_GOLANG_INSTALL_EXTRA := fs/testdata

%:
	dh $@ --buildsystem=golang --with=golang,bash-completion

## rclone 1.41

=== Makefile ===
SHELL = bash
TAG := $(shell echo $$(git describe --abbrev=8 --tags)-$${APPVEYOR_REPO_BRANCH:-$${TRAVIS_BRANCH:-$$(git rev-parse --abbrev-ref HEAD)}} | sed 's/-\([0-9]\)-/-00\1-/; s/-\([0-9][0-9]\)-/-0\1-/; s/-\(HEAD\|master\)$$//')
LAST_TAG := $(shell git describe --tags --abbrev=0)
NEW_TAG := $(shell echo $(LAST_TAG) | perl -lpe 's/v//; $$_ += 0.01; $$_ = sprintf("v%.2f", $$_)')
GO_VERSION := $(shell go version)
GO_FILES := $(shell go list ./... | grep -v /vendor/ )
# Run full tests if go >= go1.9
FULL_TESTS := $(shell go version | perl -lne 'print "go$$1.$$2" if /go(\d+)\.(\d+)/ && ($$1 > 1 || $$2 >= 9)')
BETA_URL := https://beta.rclone.org/$(TAG)/
# Pass in GOTAGS=xyz on the make command line to set build tags
ifdef GOTAGS
BUILDTAGS=-tags "$(GOTAGS)"
endif

.PHONY: rclone vars version

rclone:
	touch fs/version.go
	go install -v --ldflags "-s -X github.com/ncw/rclone/fs.Version=$(TAG)" $(BUILDTAGS)
	cp -av `go env GOPATH`/bin/rclone .

vars:
	@echo SHELL="'$(SHELL)'"
	@echo TAG="'$(TAG)'"
	@echo LAST_TAG="'$(LAST_TAG)'"
	@echo NEW_TAG="'$(NEW_TAG)'"
	@echo GO_VERSION="'$(GO_VERSION)'"
	@echo FULL_TESTS="'$(FULL_TESTS)'"
	@echo BETA_URL="'$(BETA_URL)'"

version:
	@echo '$(TAG)'

# Full suite of integration tests
test:	rclone
	go install github.com/ncw/rclone/fstest/test_all
	-go test -v -count 1 $(BUILDTAGS) $(GO_FILES) 2>&1 | tee test.log
	-test_all github.com/ncw/rclone/fs/operations github.com/ncw/rclone/fs/sync 2>&1 | tee fs/test_all.log
	@echo "Written logs in test.log and fs/test_all.log"

# Quick test
quicktest:
	RCLONE_CONFIG="/notfound" go test $(BUILDTAGS) $(GO_FILES)
ifdef FULL_TESTS
	RCLONE_CONFIG="/notfound" go test $(BUILDTAGS) -cpu=2 -race $(GO_FILES)
endif

# Do source code quality checks
check:	rclone
ifdef FULL_TESTS
	go vet $(BUILDTAGS) -printfuncs Debugf,Infof,Logf,Errorf ./...
	errcheck $(BUILDTAGS) ./...
	find . -name \*.go | grep -v /vendor/ | xargs goimports -d | grep . ; test $$? -eq 1
	go list ./... | xargs -n1 golint | grep -E -v '(StorageUrl|CdnUrl)' ; test $$? -eq 1
else
	@echo Skipping source quality tests as version of go too old
endif

# Get the build dependencies
build_dep:
ifdef FULL_TESTS
	go get -u github.com/kisielk/errcheck
	go get -u golang.org/x/tools/cmd/goimports
	go get -u github.com/golang/lint/golint
	go get -u github.com/inconshreveable/mousetrap
	go get -u github.com/tools/godep
endif

# Get the release dependencies
release_dep:
	go get -u github.com/goreleaser/nfpm

# Update dependencies
update:
	go get -u github.com/golang/dep/cmd/dep
	dep ensure -update -v

doc:	rclone.1 MANUAL.html MANUAL.txt

rclone.1:	MANUAL.md
	pandoc -s --from markdown --to man MANUAL.md -o rclone.1

MANUAL.md:	bin/make_manual.py docs/content/*.md commanddocs
	./bin/make_manual.py

MANUAL.html:	MANUAL.md
	pandoc -s --from markdown --to html MANUAL.md -o MANUAL.html

MANUAL.txt:	MANUAL.md
	pandoc -s --from markdown --to plain MANUAL.md -o MANUAL.txt

commanddocs: rclone
	rclone gendocs docs/content/commands/

rcdocs: rclone
	bin/make_rc_docs.sh

install: rclone
	install -d ${DESTDIR}/usr/bin
	install -t ${DESTDIR}/usr/bin ${GOPATH}/bin/rclone

clean:
	go clean ./...
	find . -name \*~ | xargs -r rm -f
	rm -rf build docs/public
	rm -f rclone fs/operations/operations.test fs/sync/sync.test fs/test_all.log test.log

website:
	cd docs && hugo

upload_website:	website
	rclone -v sync docs/public memstore:www-rclone-org

tarball:
	git archive -9 --format=tar.gz --prefix=rclone-$(TAG)/ -o build/rclone-$(TAG).tar.gz $(TAG)

sign_upload:
	cd build && md5sum rclone-* | gpg --clearsign > MD5SUMS
	cd build && sha1sum rclone-* | gpg --clearsign > SHA1SUMS
	cd build && sha256sum rclone-* | gpg --clearsign > SHA256SUMS

check_sign:
	cd build && gpg --verify MD5SUMS && gpg --decrypt MD5SUMS | md5sum -c
	cd build && gpg --verify SHA1SUMS && gpg --decrypt SHA1SUMS | sha1sum -c
	cd build && gpg --verify SHA256SUMS && gpg --decrypt SHA256SUMS | sha256sum -c

upload:
	rclone -v copy --exclude '*current*' build/ memstore:downloads-rclone-org/$(TAG)
	rclone -v copy --include '*current*' --include version.txt build/ memstore:downloads-rclone-org

upload_github:
	./bin/upload-github $(TAG)

cross:	doc
	go run bin/cross-compile.go -release current $(BUILDTAGS) $(TAG)

beta:
	go run bin/cross-compile.go $(BUILDTAGS) $(TAG)β
	rclone -v copy build/ memstore:pub-rclone-org/$(TAG)β
	@echo Beta release ready at https://pub.rclone.org/$(TAG)%CE%B2/

log_since_last_release:
	git log $(LAST_TAG)..

compile_all:
ifdef FULL_TESTS
	go run bin/cross-compile.go -parallel 8 -compile-only $(BUILDTAGS) $(TAG)β
else
	@echo Skipping compile all as version of go too old
endif

appveyor_upload:
	rclone --config bin/travis.rclone.conf -v copy --exclude '*beta-latest*' build/ memstore:beta-rclone-org/$(TAG)
ifeq ($(APPVEYOR_REPO_BRANCH),master)
	rclone --config bin/travis.rclone.conf -v copy --include '*beta-latest*' --include version.txt build/ memstore:beta-rclone-org
endif
	@echo Beta release ready at $(BETA_URL)

travis_beta:
	go run bin/get-github-release.go -extract nfpm goreleaser/nfpm 'nfpm_.*_Linux_x86_64.tar.gz'
	git log $(LAST_TAG).. > /tmp/git-log.txt
	go run bin/cross-compile.go -release beta-latest -git-log /tmp/git-log.txt -exclude "^windows/" -parallel 8 $(BUILDTAGS) $(TAG)β
	rclone --config bin/travis.rclone.conf -v copy --exclude '*beta-latest*' build/ memstore:beta-rclone-org/$(TAG)
ifeq ($(TRAVIS_BRANCH),master)
	rclone --config bin/travis.rclone.conf -v copy --include '*beta-latest*' --include version.txt build/ memstore:beta-rclone-org
endif
	@echo Beta release ready at $(BETA_URL)

# Fetch the windows builds from appveyor
fetch_windows:
	rclone -v copy --include 'rclone-v*-windows-*.zip' memstore:beta-rclone-org/$(TAG) build/
	-#cp -av build/rclone-v*-windows-386.zip build/rclone-current-windows-386.zip
	-#cp -av build/rclone-v*-windows-amd64.zip build/rclone-current-windows-amd64.zip
	md5sum build/rclone-*-windows-*.zip | sort

serve:	website
	cd docs && hugo server -v -w

tag:	doc
	@echo "Old tag is $(LAST_TAG)"
	@echo "New tag is $(NEW_TAG)"
	echo -e "package fs\n\n// Version of rclone\nvar Version = \"$(NEW_TAG)\"\n" | gofmt > fs/version.go
	echo -n "$(NEW_TAG)" > docs/layouts/partials/version.html
	git tag -s -m "Version $(NEW_TAG)" $(NEW_TAG)
	@echo "Edit the new changelog in docs/content/changelog.md"
	@echo "  * $(NEW_TAG) -" `date -I` >> docs/content/changelog.md
	@git log $(LAST_TAG)..$(NEW_TAG) --oneline >> docs/content/changelog.md
	@echo "Then commit the changes"
	@echo git commit -m \"Version $(NEW_TAG)\" -a -v
	@echo "And finally run make retag before make cross etc"

retag:
	git tag -f -s -m "Version $(LAST_TAG)" $(LAST_TAG)

startdev:
	echo -e "package fs\n\n// Version of rclone\nvar Version = \"$(LAST_TAG)-DEV\"\n" | gofmt > fs/version.go
	git commit -m "Start $(LAST_TAG)-DEV development" fs/version.go

winzip:
	zip -9 rclone-$(TAG).zip rclone.exe

=== debian/changelog ===
rclone (1.41-1) unstable; urgency=medium

  [ Dr. Tobias Quathamer ]
  * New upstream version 1.41. Closes: #877859
    - Refresh patches
    - New patch to disable possible privacy breach
    - Skip failing tests for now
    - Add new build dependencies
    - Update bash completion for rclone
    - Do not build qingstor and mega backends for now.
      The required go packages are not available in Debian yet.
  * Run wrap-and-sort
  * Use debhelper v11
  * Update to Standards-Version 4.1.4
    - Use Priority: optional
  * Update d/copyright
  * Update d/rules
  * Add lintian override for wrongly detected privacy breach

  [ Alexandre Viau ]
  * Point Vcs-* urls to salsa.debian.org

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sun, 13 May 2018 00:11:46 +0200

=== debian/control ===
Source: rclone
Section: net
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Dr. Tobias Quathamer <toddy@debian.org>
Build-Depends: bash-completion,
               debhelper (>= 11~),
               dh-golang,
               fuse,
               golang-any,
               golang-bazil-fuse-dev,
               golang-github-a8m-tree-dev,
               golang-github-abbot-go-http-auth-dev,
               golang-github-aws-aws-sdk-go-dev,
               golang-github-azure-azure-sdk-for-go-dev,
               golang-github-coreos-bbolt-dev,
               golang-github-djherbis-times-dev,
               golang-github-dropbox-dropbox-sdk-go-unofficial-dev,
               golang-github-jlaffaye-ftp-dev,
               golang-github-ncw-go-acd-dev,
               golang-github-ncw-swift-dev,
               golang-github-nsf-termbox-go-dev,
               golang-github-okzk-sdnotify-dev,
               golang-github-patrickmn-go-cache-dev,
               golang-github-pkg-errors-dev,
               golang-github-pkg-sftp-dev,
               golang-github-rfjakob-eme-dev,
               golang-github-sevlyar-go-daemon-dev,
               golang-github-skratchdot-open-golang-dev,
               golang-github-spf13-cobra-dev,
               golang-github-spf13-pflag-dev,
               golang-github-stretchr-testify-dev,
               golang-github-unknwon-goconfig-dev,
               golang-github-vividcortex-ewma-dev,
               golang-github-xanzy-ssh-agent-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev,
               golang-golang-x-oauth2-google-dev,
               golang-golang-x-sys-dev,
               golang-golang-x-text-dev,
               golang-golang-x-time-dev,
               golang-google-api-dev,
               golang-google-appengine-dev
Standards-Version: 4.1.4
Homepage: https://github.com/ncw/rclone
Vcs-Browser: https://salsa.debian.org/go-team/packages/rclone
Vcs-Git: https://salsa.debian.org/go-team/packages/rclone.git
XS-Go-Import-Path: github.com/ncw/rclone
Testsuite: autopkgtest-pkg-go

Package: golang-github-ncw-rclone-dev
Section: devel
Priority: optional
Architecture: all
Built-Using: ${misc:Built-Using}
Depends: golang-bazil-fuse-dev,
         golang-github-aws-aws-sdk-go-dev,
         golang-github-mreiferson-go-httpclient-dev,
         golang-github-ncw-go-acd-dev,
         golang-github-ncw-swift-dev,
         golang-github-pkg-errors-dev,
         golang-github-pkg-sftp-dev,
         golang-github-rfjakob-eme-dev,
         golang-github-skratchdot-open-golang-dev,
         golang-github-spf13-cobra-dev,
         golang-github-spf13-pflag-dev,
         golang-github-stacktic-dropbox-dev,
         golang-github-stretchr-testify-dev,
         golang-github-tsenart-tb-dev,
         golang-github-unknwon-goconfig-dev,
         golang-github-vividcortex-ewma-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev,
         golang-golang-x-oauth2-google-dev,
         golang-golang-x-sys-dev,
         golang-golang-x-text-dev,
         golang-google-api-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Description: go source code of rclone
 Rclone is a program to sync files and directories between the local
 file system and a variety of commercial cloud storage providers.
 .
 This package contains rclone's source code.

Package: rclone
Architecture: any
Built-Using: ${misc:Built-Using}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: rsync for commercial cloud storage
 Rclone is a program to sync files and directories between the local
 file system and a variety of commercial cloud storage providers:
 .
  - Google Drive
  - Amazon S3
  - Openstack Swift / Rackspace cloud files / Memset Memstore
  - Dropbox
  - Google Cloud Storage
  - Amazon Drive
  - Microsoft One Drive
  - Hubic
  - Backblaze B2
  - Yandex Disk

=== debian/rules ===
#!/usr/bin/make -f

# Do not build the qingstor and mega backends for now, the required
# go packages are not available yet.
export DH_GOLANG_EXCLUDES := backend/qingstor backend/mega

# Also install test data
export DH_GOLANG_INSTALL_EXTRA := \
	backend/alias/test \
	backend/http/test \
	cmd/lsf/testfiles \
	cmd/tree/testfiles

%:
	dh $@ --buildsystem=golang --with=golang,bash-completion

## rclone 1.45

=== Makefile ===
SHELL = bash
BRANCH := $(or $(APPVEYOR_REPO_BRANCH),$(TRAVIS_BRANCH),$(shell git rev-parse --abbrev-ref HEAD))
LAST_TAG := $(shell git describe --tags --abbrev=0)
ifeq ($(BRANCH),$(LAST_TAG))
	BRANCH := master
endif
TAG_BRANCH := -$(BRANCH)
BRANCH_PATH := branch/
ifeq ($(subst HEAD,,$(subst master,,$(BRANCH))),)
	TAG_BRANCH :=
	BRANCH_PATH :=
endif
TAG := $(shell echo $$(git describe --abbrev=8 --tags | sed 's/-\([0-9]\)-/-00\1-/; s/-\([0-9][0-9]\)-/-0\1-/'))$(TAG_BRANCH)
NEW_TAG := $(shell echo $(LAST_TAG) | perl -lpe 's/v//; $$_ += 0.01; $$_ = sprintf("v%.2f", $$_)')
ifneq ($(TAG),$(LAST_TAG))
	TAG := $(TAG)-beta
endif
GO_VERSION := $(shell go version)
GO_FILES := $(shell go list ./... | grep -v /vendor/ )
# Run full tests if go >= go1.11
FULL_TESTS := $(shell go version | perl -lne 'print "go$$1.$$2" if /go(\d+)\.(\d+)/ && ($$1 > 1 || $$2 >= 11)')
BETA_PATH := $(BRANCH_PATH)$(TAG)
BETA_URL := https://beta.rclone.org/$(BETA_PATH)/
BETA_UPLOAD_ROOT := memstore:beta-rclone-org
BETA_UPLOAD := $(BETA_UPLOAD_ROOT)/$(BETA_PATH)
# Pass in GOTAGS=xyz on the make command line to set build tags
ifdef GOTAGS
BUILDTAGS=-tags "$(GOTAGS)"
endif

.PHONY: rclone vars version

rclone:
	touch fs/version.go
	go install -v --ldflags "-s -X github.com/ncw/rclone/fs.Version=$(TAG)" $(BUILDTAGS)
	cp -av `go env GOPATH`/bin/rclone .

vars:
	@echo SHELL="'$(SHELL)'"
	@echo BRANCH="'$(BRANCH)'"
	@echo TAG="'$(TAG)'"
	@echo LAST_TAG="'$(LAST_TAG)'"
	@echo NEW_TAG="'$(NEW_TAG)'"
	@echo GO_VERSION="'$(GO_VERSION)'"
	@echo FULL_TESTS="'$(FULL_TESTS)'"
	@echo BETA_URL="'$(BETA_URL)'"

version:
	@echo '$(TAG)'

# Full suite of integration tests
test:	rclone
	go install --ldflags "-s -X github.com/ncw/rclone/fs.Version=$(TAG)" $(BUILDTAGS) github.com/ncw/rclone/fstest/test_all
	-test_all 2>&1 | tee test_all.log
	@echo "Written logs in test_all.log"

# Quick test
quicktest:
	RCLONE_CONFIG="/notfound" go test $(BUILDTAGS) $(GO_FILES)
ifdef FULL_TESTS
	RCLONE_CONFIG="/notfound" go test $(BUILDTAGS) -cpu=2 -race $(GO_FILES)
endif

# Do source code quality checks
check:	rclone
ifdef FULL_TESTS
	go vet $(BUILDTAGS) -printfuncs Debugf,Infof,Logf,Errorf ./...
	errcheck $(BUILDTAGS) ./...
	find . -name \*.go | grep -v /vendor/ | xargs goimports -d | grep . ; test $$? -eq 1
	go list ./... | xargs -n1 golint | grep -E -v '(StorageUrl|CdnUrl)' ; test $$? -eq 1
else
	@echo Skipping source quality tests as version of go too old
endif

gometalinter_install:
	go get -u github.com/alecthomas/gometalinter
	gometalinter --install --update

# We aren't using gometalinter as the default linter yet because
# 1. it doesn't support build tags: https://github.com/alecthomas/gometalinter/issues/275
# 2. can't get -printfuncs working with the vet linter
gometalinter:
	gometalinter ./...

# Get the build dependencies
build_dep:
ifdef FULL_TESTS
	go get -u github.com/kisielk/errcheck
	go get -u golang.org/x/tools/cmd/goimports
	go get -u golang.org/x/lint/golint
endif

# Get the release dependencies
release_dep:
	go get -u github.com/goreleaser/nfpm/...
	go get -u github.com/aktau/github-release

# Update dependencies
update:
	GO111MODULE=on go get -u ./...
	GO111MODULE=on go mod tidy
	GO111MODULE=on go mod vendor

doc:	rclone.1 MANUAL.html MANUAL.txt rcdocs commanddocs

rclone.1:	MANUAL.md
	pandoc -s --from markdown --to man MANUAL.md -o rclone.1

MANUAL.md:	bin/make_manual.py docs/content/*.md commanddocs backenddocs
	./bin/make_manual.py

MANUAL.html:	MANUAL.md
	pandoc -s --from markdown --to html MANUAL.md -o MANUAL.html

MANUAL.txt:	MANUAL.md
	pandoc -s --from markdown --to plain MANUAL.md -o MANUAL.txt

commanddocs: rclone
	XDG_CACHE_HOME="" XDG_CONFIG_HOME="" HOME="\$$HOME" USER="\$$USER" rclone gendocs docs/content/commands/

backenddocs: rclone bin/make_backend_docs.py
	./bin/make_backend_docs.py

rcdocs: rclone
	bin/make_rc_docs.sh

install: rclone
	install -d ${DESTDIR}/usr/bin
	install -t ${DESTDIR}/usr/bin ${GOPATH}/bin/rclone

clean:
	go clean ./...
	find . -name \*~ | xargs -r rm -f
	rm -rf build docs/public
	rm -f rclone fs/operations/operations.test fs/sync/sync.test fs/test_all.log test.log

website:
	cd docs && hugo

upload_website:	website
	rclone -v sync docs/public memstore:www-rclone-org

tarball:
	git archive -9 --format=tar.gz --prefix=rclone-$(TAG)/ -o build/rclone-$(TAG).tar.gz $(TAG)

sign_upload:
	cd build && md5sum rclone-v* | gpg --clearsign > MD5SUMS
	cd build && sha1sum rclone-v* | gpg --clearsign > SHA1SUMS
	cd build && sha256sum rclone-v* | gpg --clearsign > SHA256SUMS

check_sign:
	cd build && gpg --verify MD5SUMS && gpg --decrypt MD5SUMS | md5sum -c
	cd build && gpg --verify SHA1SUMS && gpg --decrypt SHA1SUMS | sha1sum -c
	cd build && gpg --verify SHA256SUMS && gpg --decrypt SHA256SUMS | sha256sum -c

upload:
	rclone -P copy build/ memstore:downloads-rclone-org/$(TAG)
	rclone lsf build --files-only --include '*.{zip,deb,rpm}' --include version.txt | xargs -i bash -c 'i={}; j="$$i"; [[ $$i =~ (.*)(-v[0-9\.]+-)(.*) ]] && j=$${BASH_REMATCH[1]}-current-$${BASH_REMATCH[3]}; rclone copyto -v "memstore:downloads-rclone-org/$(TAG)/$$i" "memstore:downloads-rclone-org/$$j"'

upload_github:
	./bin/upload-github $(TAG)

cross:	doc
	go run bin/cross-compile.go -release current $(BUILDTAGS) $(TAG)

beta:
	go run bin/cross-compile.go $(BUILDTAGS) $(TAG)
	rclone -v copy build/ memstore:pub-rclone-org/$(TAG)
	@echo Beta release ready at https://pub.rclone.org/$(TAG)/

log_since_last_release:
	git log $(LAST_TAG)..

compile_all:
ifdef FULL_TESTS
	go run bin/cross-compile.go -parallel 8 -compile-only $(BUILDTAGS) $(TAG)
else
	@echo Skipping compile all as version of go too old
endif

appveyor_upload:
	rclone --config bin/travis.rclone.conf -v copy --exclude '*beta-latest*' build/ $(BETA_UPLOAD)
ifndef BRANCH_PATH
	rclone --config bin/travis.rclone.conf -v copy --include '*beta-latest*' --include version.txt build/ $(BETA_UPLOAD_ROOT)
endif
	@echo Beta release ready at $(BETA_URL)

BUILD_FLAGS := -exclude "^(windows|darwin)/"
ifeq ($(TRAVIS_OS_NAME),osx)
	BUILD_FLAGS := -include "^darwin/" -cgo
endif

travis_beta:
ifeq ($(TRAVIS_OS_NAME),linux)
	go run bin/get-github-release.go -extract nfpm goreleaser/nfpm 'nfpm_.*_Linux_x86_64.tar.gz'
endif
	git log $(LAST_TAG).. > /tmp/git-log.txt
	go run bin/cross-compile.go -release beta-latest -git-log /tmp/git-log.txt $(BUILD_FLAGS) -parallel 8 $(BUILDTAGS) $(TAG)
	rclone --config bin/travis.rclone.conf -v copy --exclude '*beta-latest*' build/ $(BETA_UPLOAD)
ifndef BRANCH_PATH
	rclone --config bin/travis.rclone.conf -v copy --include '*beta-latest*' --include version.txt build/ $(BETA_UPLOAD_ROOT)
endif
	@echo Beta release ready at $(BETA_URL)

# Fetch the binary builds from travis and appveyor
fetch_binaries:
	rclone -P sync $(BETA_UPLOAD) build/

serve:	website
	cd docs && hugo server -v -w

tag:	doc
	@echo "Old tag is $(LAST_TAG)"
	@echo "New tag is $(NEW_TAG)"
	echo -e "package fs\n\n// Version of rclone\nvar Version = \"$(NEW_TAG)\"\n" | gofmt > fs/version.go
	echo -n "$(NEW_TAG)" > docs/layouts/partials/version.html
	git tag -s -m "Version $(NEW_TAG)" $(NEW_TAG)
	bin/make_changelog.py $(LAST_TAG) $(NEW_TAG) > docs/content/changelog.md.new
	mv docs/content/changelog.md.new docs/content/changelog.md
	@echo "Edit the new changelog in docs/content/changelog.md"
	@echo "Then commit all the changes"
	@echo git commit -m \"Version $(NEW_TAG)\" -a -v
	@echo "And finally run make retag before make cross etc"

retag:
	git tag -f -s -m "Version $(LAST_TAG)" $(LAST_TAG)

startdev:
	echo -e "package fs\n\n// Version of rclone\nvar Version = \"$(LAST_TAG)-DEV\"\n" | gofmt > fs/version.go
	git commit -m "Start $(LAST_TAG)-DEV development" fs/version.go

winzip:
	zip -9 rclone-$(TAG).zip rclone.exe

=== debian/changelog ===
rclone (1.45-3) unstable; urgency=medium

  * d/rules: increase test timeout.
    Some architectures like mips are slow to run test

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 10 Jun 2019 02:22:04 +0800

rclone (1.45-2) unstable; urgency=medium

  * Add versioned Build-Depends.
    The recent upload of golang-github-okzk-sdnotify makes
    the older version of rclone (in testing) FTBFS.
    Thanks to Paul Gevers <elbrus@debian.org> (Closes: #915907)
  * Disable autopkgtest-pkg-go

 -- Dr. Tobias Quathamer <toddy@debian.org>  Wed, 12 Dec 2018 09:40:34 +0100

rclone (1.45-1) unstable; urgency=medium

  * New upstream version 1.45. Closes: #903202
    - Refresh patches
    - New patch to disable FTP server of rclone.
      The Build-Dependency is not available in Debian yet.
    - Update dependencies
    - Ignore two more failing tests
    - Include another testdata directory
    - Update bash completion script
  * Remove Built-Using from -dev package
  * Remove Priority from -dev package
  * Update Standards-Version to 4.2.1, no changes needed

 -- Dr. Tobias Quathamer <toddy@debian.org>  Wed, 05 Dec 2018 21:53:01 +0100

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                golang-github-a8m-tree-dev,
                golang-github-abbot-go-http-auth-dev,
                golang-github-aws-aws-sdk-go-dev,
-               golang-github-azure-azure-sdk-for-go-dev,
+               golang-github-azure-azure-storage-blob-go-dev,
                golang-github-coreos-bbolt-dev,
                golang-github-djherbis-times-dev,
                golang-github-dropbox-dropbox-sdk-go-unofficial-dev,
@@ -23,7 +23,6 @@
                golang-github-okzk-sdnotify-dev,
                golang-github-patrickmn-go-cache-dev,
                golang-github-pkg-errors-dev,
-               golang-github-pkg-sftp-dev,
                golang-github-rfjakob-eme-dev,
                golang-github-sevlyar-go-daemon-dev,
                golang-github-skratchdot-open-golang-dev,
@@ -31,7 +30,6 @@
                golang-github-spf13-pflag-dev,
                golang-github-stretchr-testify-dev,
                golang-github-unknwon-goconfig-dev,
-               golang-github-vividcortex-ewma-dev,
                golang-github-xanzy-ssh-agent-dev,
                golang-golang-x-crypto-dev,
                golang-golang-x-net-dev,
@@ -39,41 +37,45 @@
                golang-golang-x-sys-dev,
                golang-golang-x-text-dev,
                golang-golang-x-time-dev,
-               golang-google-api-dev,
-               golang-google-appengine-dev
-Standards-Version: 4.1.4
+               golang-google-api-dev
+Standards-Version: 4.2.1
 Homepage: https://github.com/ncw/rclone
 Vcs-Browser: https://salsa.debian.org/go-team/packages/rclone
 Vcs-Git: https://salsa.debian.org/go-team/packages/rclone.git
 XS-Go-Import-Path: github.com/ncw/rclone
-Testsuite: autopkgtest-pkg-go
 
 Package: golang-github-ncw-rclone-dev
 Section: devel
-Priority: optional
 Architecture: all
-Built-Using: ${misc:Built-Using}
 Depends: golang-bazil-fuse-dev,
+         golang-github-a8m-tree-dev,
+         golang-github-abbot-go-http-auth-dev,
          golang-github-aws-aws-sdk-go-dev,
-         golang-github-mreiferson-go-httpclient-dev,
+         golang-github-azure-azure-storage-blob-go-dev,
+         golang-github-coreos-bbolt-dev,
+         golang-github-djherbis-times-dev,
+         golang-github-dropbox-dropbox-sdk-go-unofficial-dev,
+         golang-github-jlaffaye-ftp-dev,
          golang-github-ncw-go-acd-dev,
          golang-github-ncw-swift-dev,
+         golang-github-nsf-termbox-go-dev,
+         golang-github-okzk-sdnotify-dev (>= 0.0~git20180710.d9becc3-1),
+         golang-github-patrickmn-go-cache-dev,
          golang-github-pkg-errors-dev,
-         golang-github-pkg-sftp-dev,
          golang-github-rfjakob-eme-dev,
+         golang-github-sevlyar-go-daemon-dev,
          golang-github-skratchdot-open-golang-dev,
          golang-github-spf13-cobra-dev,
          golang-github-spf13-pflag-dev,
-         golang-github-stacktic-dropbox-dev,
          golang-github-stretchr-testify-dev,
-         golang-github-tsenart-tb-dev,
          golang-github-unknwon-goconfig-dev,
-         golang-github-vividcortex-ewma-dev,
+         golang-github-xanzy-ssh-agent-dev,
          golang-golang-x-crypto-dev,
          golang-golang-x-net-dev,
          golang-golang-x-oauth2-google-dev,
          golang-golang-x-sys-dev,
          golang-golang-x-text-dev,
+         golang-golang-x-time-dev,
          golang-google-api-dev,
          ${misc:Depends},
          ${shlibs:Depends}

=== debian/rules ===
--- 
+++ 
@@ -7,9 +7,13 @@
 # Also install test data
 export DH_GOLANG_INSTALL_EXTRA := \
 	backend/alias/test \
+	backend/drive/test \
 	backend/http/test \
 	cmd/lsf/testfiles \
 	cmd/tree/testfiles
 
 %:
 	dh $@ --buildsystem=golang --with=golang,bash-completion
+
+override_dh_auto_test:
+	dh_auto_test -- -timeout 20m
